#! /bin/sh

# I use this to convert segy files to sep

D='Data'
file_prefix='bp_TTI_s100m_r25m_16'
file_suffix='.segy'
dir=`pwd`
echo ${dir}

sep_file=${file_prefix}'.H'
in_file=${file_prefix}'.H@'
hff_file=${file_prefix}'.H@@'
segy_file=${dir}'/'${file_prefix}${file_suffix}
binary_file='binary_'${sep_file}
ascii_file='ascii_'${sep_file}

echo ${sep_file}
echo ${segy_file}
echo ${binary_file}
echo ${ascii_file}

Segy2sep > ${dir}'/'${sep_file} tape=${segy_file} bfile=${dir}'/'${binary_file} \
	hfile=${dir}'/'${ascii_file} in=${in_file} hff=${hff_file} endian=0 \
	keeplist=trid:mute:muts:laga:scalco:sx:sy:gx:gy verbose=1 vblock=10000 \
	extra_name1=line_no extra_offset1=189 extra_type1=i extra_name2=cdp_no \
	extra_offset2=193 extra_type2=i extra_name3=cdp_x extra_offset3=181 extra_type3=i \
	extra_name4=cdp_y extra_offset4=185 extra_type4=i nextra_keys=4 NULL& 
