/*C version of propagation kernel*/

export void gradX2(uniform int adj, uniform int add,  uniform float p[], uniform float pxx[],
                  uniform int nz, uniform int i2, uniform float dx){

uniform int n1=nz;

uniform float idx = 1.0/(dx*dx);
uniform float a0 =-3.12513824*idx;
uniform float ax1= 1.84108651*idx;
uniform float ax2=-0.35706478*idx;
uniform float ax3= 0.10185626*idx;
uniform float ax4=-0.02924772*idx;
uniform float ax5= 0.00696837*idx;
uniform float ax6=-0.00102952*idx;

if(adj==1) {
  uniform int i=i2*n1;
  if(add==0) {
    for(uniform int i1=0;i1<n1;i1++) {
      pxx[i1+i]=0.f;
    }
  }  
  foreach(i1=0...(n1-1)){
      pxx[i1+i]=
        ax1*(p[i1+i-1*n1]+p[i1+i+1*n1])+
        ax2*(p[i1+i-2*n1]+p[i1+i+2*n1])+
        ax3*(p[i1+i-3*n1]+p[i1+i+3*n1])+
        ax4*(p[i1+i-4*n1]+p[i1+i+4*n1])+
        ax5*(p[i1+i-5*n1]+p[i1+i+5*n1])+
        ax6*(p[i1+i-6*n1]+p[i1+i+6*n1])+
        a0*p[i1+i];
  }
}
else {
  uniform int i=i2*n1;
  if(add==0) {
    for(uniform int i1=0;i1<n1;i1++) {
      pxx[i1+i]=0.f;
    }
  }  
  foreach(i1=0...(n1-1)){
      pxx[i1+i]=
        ax1*(p[i1+i-1*n1]+p[i1+i+1*n1])+
        ax2*(p[i1+i-2*n1]+p[i1+i+2*n1])+
        ax3*(p[i1+i-3*n1]+p[i1+i+3*n1])+
        ax4*(p[i1+i-4*n1]+p[i1+i+4*n1])+
        ax5*(p[i1+i-5*n1]+p[i1+i+5*n1])+
        ax6*(p[i1+i-6*n1]+p[i1+i+6*n1])+
        a0*p[i1+i];//+
  }
}

}
