MODULE rtm_mod 
USE SEP
IMPLICIT NONE

CONTAINS
  SUBROUTINE rtm_init(dt,am)
    IMPLICIT NONE

    REAL, INTENT(IN) :: dt

    REAL, DIMENSION(0:2), INTENT(OUT)     :: am

    !*****************************************
    !* Calculate parameters for Lax-Wendroff *
    !*****************************************
    WRITE(0,*) 'Calculate Lax-Wendroff parameters'
    am(0) = 2.0
    am(1) = dt**2
    am(2) = (dt**4)/12.0
  END SUBROUTINE
END MODULE
